#!/usr/bin/env python
import random
import sys

def generate(n, m, fin):
  edges = set()
  sizes = [random.randint(1,n/2) for i in range(n)]
  for i in range(m):
    a = random.randint(1, n)
    b = random.randint(1, n)
    if a > b:
      a,b = b,a
    if a != b:
      if (a,b) not in edges:
        edges.add((a,b))
  fin.write("%d %d\n" % (n, len(edges)))
  fin.write("%s\n" % (" ".join(map(str, sizes))))
  for a,b in edges:
    fin.write("%d %d\n" % (a, b))

for i in range(1, 21, 1):
  with open('secret/%02d.in' % (i), 'w') as f:
    random.seed(hash('ukiepc2018') ^ i)
    n = random.randint(2, 1000)
    m = random.randint(1, 10**5)
    generate(n, m, f)
