#!/usr/bin/env pypy
from random import randint, seed, shuffle
from bisect import bisect_left

magic_seed = 413151617181

def shuffled(arr):
  arr = arr[:]
  shuffle(arr)
  return arr

def generate(inf, fi):
  me = inf[0]
  buses = inf[1]
  length = inf[2]
  assert me <= length

  fi.write('%d %d %d\n' % (me, buses, length))
  for i in range(buses):
    line = ''.join([str(randint(0,1)) for _ in range(length)])
    fi.write('%s\n' % line)

cases = {
  1: [3, 10, 10],
  2: [4, 20, 10],
  3: [5, 30, 10],
  4: [10, 10, 50],
  5: [10, 10, 50],
  6: [20, 10, 50],
  7: [30, 10, 50 ],
  8: [40, 10, 50],
}

for tseed,tid in enumerate(cases.keys()):
  tinf = cases[tid]
  seed(magic_seed ^ tseed)
  with open('secret/%02d.in' % tid, 'w') as fi:
    generate(tinf, fi)
