#!/usr/bin/env python

"""
run to create the figure on the problem statement.
the input used is the first line of ../data/sample/1.in
"""

from math import sin,cos,pi,hypot

colours = [
  'LimeGreen', 'blue',
  'red', 'ProcessBlue',
  'brown', 'black']

if __name__ == '__main__':
  f = open('../data/sample/1.in', 'r')
  ff = map(lambda s: s.strip(), f.readlines())
  routes = ff[1:]
  s = [
    '\\documentclass[class=article,border=0pt]{standalone}\n',
    '\\usepackage[usenames,dvipsnames]{xcolor}\n',
    '\\usepackage{tikz}\n',
    '\\begin{document}\n',
    '\\pagestyle{empty}\n',
    '\\thispagestyle{empty}\n',
    '\\begin{tikzpicture}[scale=0.25]\n']
  y0 = 0
  k = 0

  def get_theta(i):
    return i * 2*pi / len(route) + 0.4

  for i,route in enumerate(routes):
    radius = i*4 + 5

    y = 5 + 8 * i
    xt = 5 + 10 * (len(route) - 1)

    # Draw the line.
    s.append('\\draw (0,0) circle ({0});\n'.format((radius)))

    # Draw the coloured bus stops.
    for j in range(len(route)):
      x = sin(get_theta(j)) * radius
      y = cos(get_theta(j)) * radius
      if route[j] == '1':
        s.append('\\draw[fill={2}] ({0}, {1}) circle (1.5);\n'.format(x, y, colours[i % len(colours)]))

      else:
        s.append('\\draw[fill=white] ({0}, {1}) circle (1);\n'.format(x, y))

    # Draw Max.
    Max = int(ff[0].split()[0])-1
    if route[Max] == '1':
      max_x = sin(get_theta(Max)) * radius
      max_y = cos(get_theta(Max)) * radius
      s.append('\\draw[fill=white] ({0}, {1}) circle (0.5);\n'.format(max_x, max_y))

  s.append('\\end{tikzpicture}\n')
  s.append('\\end{document}\n')
  f = open('fig.tex', 'w')
  for x in s:
    f.write(x)
  f.close()
