import java.util.Arrays;
import java.util.Scanner;
import java.util.stream.IntStream;

public class rgl {
  private static final long mod = 1000000007;

  private static long total(long[][] v) {
    return Arrays.stream(v).parallel().mapToLong(x -> Arrays.stream(x).sum()).sum() % mod;
  }

  private static void iterate(long[][] src, long[][] dst) {
    final long t = total(src);
    IntStream.range(0, src.length).parallel().forEach(
        i -> {
          for (int j = 0; j < src[i].length; j++) {
            dst[i][j] = t + mod * 100 * 100;
            for (int k = Math.max(0, i-1); k < Math.min(src.length, i+2); k++) {
              for (int l = Math.max(0, j-1); l < Math.min(src[i].length, j+2); l++) {
                dst[i][j] -= src[k][l];
              }
            }
            dst[i][j] %= mod;
          }
        });
  }

  public static void main(String[] args) {
    Scanner sc = new Scanner(System.in);
    final int r = sc.nextInt();
    final int c = sc.nextInt();
    final int n = sc.nextInt();

    long[][] a = new long[r][c];
    long[][] b = new long[r][c];
    Arrays.stream(a).parallel().forEach(
        x -> {
          for (int i=0; i<c; i++) {
            x[i]=1;
          }
        });

    for (int i=1; i<n; i++) {
      iterate(a, b);
      long[][] t = a;
      a = b;
      b = t;
    }
    System.out.println(total(a));
  }
}
