#include <bits/stdc++.h>
using namespace std;

// constexpr int max_n=1'000'000;
constexpr int max_n=1000000;

bool type[max_n];
int a[max_n];
set<int> edge[max_n];
vector<int> anti_edge[max_n];
int n;

template <class T>
T const &random_element(vector<T> const &v){
  return v[rand()%v.size()];
}

int main(){
  cin>>n;
  vector<int> half[2];

  for (int i=0; i<n; i++){
    int p; cin>>type[i]>>p; --p;
    half[type[i]].push_back(i);
    if (i!=p){
      edge[i].insert(p);
      edge[p].insert(i);
    }
  }

  if (half[0].size()!=half[1].size()){
    cout<<"impossible"<<endl;
    return 0;
  }

  vector<int> cardinality(n);
  vector<int> v(n);
  for (int i=n; i--;){
    cardinality[i]=n/2-edge[i].size();
    v[i]=i;
  }
  sort(v.begin(),v.end(),[&cardinality](int a,int b){return cardinality[a]<cardinality[b];});

  int left=0;
  while (left<n and cardinality[left]*3<n) ++left;
  for (int i=0; i<left; i++)
    for (int j=0; j<n; j++)
      if (type[v[i]]!=type[j] and not edge[v[i]].count(j))
        anti_edge[v[i]].push_back(j);

  for (int z=0; z<40; z++){
    memset(a,-1,sizeof a);
    int u[2]={n/2-1,n/2-1};

    // Assign the sparse vertices from an explicit edge set.
    for (int i=0; i<left; i++){
      if (a[v[i]]==-1){
        if (anti_edge[v[i]].empty()){
          goto failed;
        }
        a[v[i]]=random_element(anti_edge[v[i]]);
        if (a[a[v[i]]]!=-1 and a[a[v[i]]]!=v[i]){
          goto failed;
        }
        a[a[v[i]]]=v[i];
      }
    }

    // Assign the dense vertices at random and hope it works.
    random_shuffle(half[0].begin(),half[0].end());
    random_shuffle(half[1].begin(),half[1].end());

    for (int i=left; i<n; i++){
      if (a[v[i]]==-1){
        int g=!type[v[i]]; int &uu=u[g];
        while (uu>=0 and a[half[g][uu]]!=-1) --uu;
        if (uu<0 or edge[half[g][uu]].count(v[i])){
          goto failed;
        }
        a[v[i]]=half[g][uu];
        a[half[g][uu]]=v[i];
        --uu;
      }
    }

    for (int i=0,j=0; i<n; i++) if (type[i]==1) cout<<(j++?" ":"")<<i+1; cout<<endl;
    for (int i=0,j=0; i<n; i++) if (type[i]==1) cout<<(j++?" ":"")<<a[i]+1; cout<<endl;

    passed: return 0;
    failed: continue;
  }

  cout<<"impossible"<<endl;
}
