#include <bits/stdc++.h>
using namespace std;

vector<int> type;
vector<set<int>> child;

set<int> roots;
vector<int> root_size;

int dfs(int x){
  root_size[x]=1;
  for (auto y: child[x])
    if (root_size[y]==0)
      root_size[x]+=dfs(y);
  return root_size[x];
}

int find_centroid(int x,int total){
  pair<int,int> biggest={-1,-1};
  for (auto y: child[x])
    if (root_size[y]<root_size[x])
      biggest=max(biggest,{root_size[y],y});

  if (biggest.first*2<=total){
    return x;
  }
  return find_centroid(biggest.second,total);
}

int find_centroid_match(int x,int r,int p=-1){
  if (x!=r and p!=r and type[x]!=type[r]){
    return x;
  }
  for (auto y: child[x])
    if (y!=p){
      int ret=find_centroid_match(y,r,x);
      if (ret!=-1) return ret;
    }
  return -1;
}

void populate(int x,tuple<int,int,vector<int>*> *g[2]){
  get<0>(*g[type[x]])++;
  get<2>(*g[type[x]])->push_back(x);
  for (auto y: child[x])
    if (root_size[y]<root_size[x])
      populate(y,g);
}

int main(){
  int n; cin>>n;

  type.resize(n);
  child.resize(n);

  for (int i=0; i<n; i++){
    int p; cin>>type[i]>>p; --p;
    child[i].insert(p);
    child[p].insert(i);
  }

  root_size.assign(n,0);
  for (int i=n; i--;)
    if (root_size[i]==0){
      roots.insert(i);
      dfs(i);
    }

  // Choose largest tree in forest. We'll find its centroid.
  int biggest_root=0;
  for (auto i: roots)
    if (root_size[i]>=root_size[biggest_root])
      biggest_root=i;
  int const a=find_centroid(biggest_root,root_size[biggest_root]);

  // Can we find a match for our centroid?
  int b=find_centroid_match(a,a);
  for (int i=n; i--;)
    if (b==-1 and type[a]!=type[b] and not child[a].count(b))
      b=i;
  if (b==-1){
    cout<<"impossible"<<endl;
    return 0;
  }

  vector<pair<int,int>> res={{a,b}};

  // Rebuild the forest without vertices a and b.
  for (int i=n; i--;)
    child[i].erase(a), child[i].erase(b);
  root_size.assign(n,0);

  // SELECT vertices GROUP BY root, colour SORT BY size DESC
  priority_queue<tuple<int,int,vector<int>*>> groups[2];
  for (int i=n; i--;)
    if (i!=a and i!=b and root_size[i]==0){
      dfs(i);
      tuple<int,int,vector<int>*> s{0,i,new vector<int>()};
      tuple<int,int,vector<int>*> t{0,i,new vector<int>()};
      tuple<int,int,vector<int>*>* arr[2]={&s,&t};
      populate(i,arr);
      if (get<0>(s)){
        groups[0].emplace(s);
        cerr<<"creating group[0] ("<<i+1<<"):";
        for (auto i: *get<2>(s)) cerr<<" "<<i+1; cerr<<endl;
      }
      if (get<0>(t)){
        groups[1].emplace(t);
        cerr<<"creating group[1] ("<<i+1<<"):";
        for (auto i: *get<2>(t)) cerr<<" "<<i+1; cerr<<endl;
      }
    }

  while (not groups[0].empty() and not groups[1].empty()){
    auto u=groups[0].top(); groups[0].pop();
    auto v=groups[1].top(); groups[1].pop();
    // cerr<<"pairing up "<<get<0>(u)<<"="<<get<1>(u)<<" and "<<get<0>(v)<<"="<<get<1>(v)<<endl;

    if (get<1>(u)==get<1>(v)){
      if (groups[0].empty() and groups[1].empty()){
        cerr<<"  only pairs left are in the same component"<<endl;
        break;
      }
      if (get<0>(u)>=get<0>(v)){
        auto w=groups[1].top(); groups[1].pop(); groups[1].push(v); v=w;
      }else{
        auto w=groups[0].top(); groups[0].pop(); groups[0].push(u); u=w;
      }
    }

    cerr<<"  pairing "<<1+get<2>(u)->back()<<" and "<<1+get<2>(v)->back()<<endl;

    res.emplace_back(get<2>(u)->back(),get<2>(v)->back());
    get<2>(u)->pop_back(); if (--get<0>(u)) groups[0].push(u);
    get<2>(v)->pop_back(); if (--get<0>(v)) groups[1].push(v);
  }

  if (res.size()==n/2){
    int z=0; for (auto i: res) cout<<(z++?" ":"")<<(type[i.first]?i.first:i.second)+1; cout<<endl;
    int w=0; for (auto i: res) cout<<(w++?" ":"")<<(type[i.first]?i.second:i.first)+1; cout<<endl;
    return 0;
  }else{
    cout<<"impossible"<<endl;
  }
}
