#include <algorithm>
#include <iostream>
#include <queue>
#include <set>
#include <map>
using namespace std;

int fibonacci[40]={1,1};

template <class ST> struct FrequencyCounter{
  set<pair<int,ST> > code_group[37]; // F(36) = 14930352
  map<ST,int> sym_frequency;
  map<ST,int> sym_group;

  int total_length;

  void insert_symbol(ST s){
    for (int i=0;; i++){
      if (code_group[i].size()<fibonacci[i]){
        code_group[i].insert(make_pair(0,s));
        sym_group[s]=i;
        return;
      }
    }
  }

  void increase_symbol(ST s){
    if (sym_frequency[s]==0) insert_symbol(s);

    int &g=sym_group[s]; int &f=sym_frequency[s];
    total_length-=f*(g+2);

    for (code_group[g].erase(make_pair(f++,s)); g and code_group[g-1].begin()->first<f; --g){
      ST const l=code_group[g-1].begin()->second;

      code_group[g-1].erase(make_pair(sym_frequency[l],l));
      code_group[g].insert(make_pair(sym_frequency[l],l));
      total_length+=sym_frequency[l];
      sym_group[l]=g;
    }
    code_group[g].insert(make_pair(f,s));
    total_length+=f*(g+2);
  }
};

int main(){
  int n; cin>>n;
  vector<int> s(n); for (auto &i: s) cin>>i;

  for (int i=2; i<40; i++) fibonacci[i]=fibonacci[i-1]+fibonacci[i-2];

  int res=0;
  FrequencyCounter<int> fc={};
  for (int i=0; i<n; i++){
    fc.increase_symbol(s[i]);
    cout<<fc.total_length<<endl;
  }
}

