import java.util.*;
import java.util.stream.*;

public class author {
  public static void main(String[] args) {
    final Solver solver = new Solver();
    final Scanner sc = new Scanner(System.in).useDelimiter("\\n");
    final int n = sc.nextInt();
    Arrays.stream(sc.next().split(" ")).map(Integer::parseInt).forEach(solver::add);
  }

  private static class Solver {
    final Map<Integer, Integer> itemFrequency = new HashMap<>();
    final List<Integer> costAt = new ArrayList<>();
    final NavigableMap<Integer, Integer> boundaries = new TreeMap<>();

    int value = 0;
    int itemCount = 0;

    public void add(int x) {
      if (!itemFrequency.containsKey(x)) {
        itemFrequency.put(x, 0);
        costAt.add(CodeCount.inverse(itemCount));
        boundaries.put(0, itemCount);
        itemCount += 1;
      }

      final int oldFreq = itemFrequency.get(x);
      final int newFreq = oldFreq + 1;
      itemFrequency.put(x, newFreq);

      // Convert leftmost oldFreq into a newFreq.
      value += costAt.get(boundaries.get(oldFreq));

      // Create the range for newFreq if necessary.
      if (!boundaries.containsKey(newFreq)) {
        boundaries.put(newFreq, boundaries.get(oldFreq));
      }

      // Shorten the range for oldFreq by 1.
      boundaries.put(oldFreq, boundaries.get(oldFreq) + 1);
      if (boundaries.get(oldFreq) == itemFrequency.size()
          || oldFreq != boundaries.firstKey() && boundaries.get(oldFreq) == boundaries.lowerEntry(oldFreq).getValue()) {
        boundaries.remove(oldFreq);
      }

      System.out.println(value);
    }
  }

  private static class CodeCount {
    private static final int[] cache = new int[100];

    public static final int get(int x) {
      return x <= 3
        ? x <= 1 ? 0 : 1
        : cache[x] != 0
          ? (cache[x])
          : (cache[x] = get(x-1) + get(x-2));
    }

    public static final int inverse(int y) {
      int x = 2; while (get(x) <= y) y -= get(x++); return x;
    }
  }
}
