import java.lang.Math;
import java.util.*;

public class rglbs {
  public static void main(String[] args) {
    final Scanner sc = new Scanner(System.in);
    final double t = sc.nextDouble();
    final int n = sc.nextInt();
    final NavigableMap<Double, Integer> b = new TreeMap<>();

    long total = 0;
    for (int i = 0; i < n; i++) {
      int q = sc.nextInt();
      double r = sc.nextDouble();
      if (!b.containsKey(r)) {
        b.put(r, q);
      } else {
        b.put(r, q + b.get(r));
      }
      total += q;
    }

    System.out.println("" + solve(b, t, 0, total + 1));
  }

  private static long solve(NavigableMap<Double, Integer> freq, double t, long l, long r) {
    if (l + 1 == r) {
      return l;
    }
    long m = (l / 2) + (r / 2) + (l & r & 1);
    if (2 * Math.PI * get(freq, m) <= t) {
      return solve(freq, t, m, r);
    } else {
      return solve(freq, t, l, m);
    }
  }

  private static double get(NavigableMap<Double, Integer> freq, long upTo) {
    double res = 0.0;
    for (Map.Entry<Double, Integer> i : freq.entrySet()) {
      long take = Math.min(upTo, (long) i.getValue());
      res += take * i.getKey();
      upTo -= take;
    }
    return res;
  }
}
