#include <algorithm>
#include <cstdlib>
#include <cassert>
#include <cstdio>

long long dist[201][201];
long long rist[201][201];

void validate(bool condition,char const* message){
  if (not condition){
    puts(message);
    exit(43);
  }
}

int main(){
  int m,n; scanf(" %d %d",&m,&n);

  for (int i=0; i<n; i++){
    // Skip validating time constraints, CTD will do that for us.
    scanf(" %*d %*d %*d");
  }

  for (int i=0; i<n; i++){
    for (int j=0; j<n; j++){
      scanf(" %lld", &dist[i][j]);
      if (i==j){
        validate(dist[i][j]==0, "Not all diagonals are 0");
      }else{
        validate(dist[i][j]!=0, "At least one non-diagonal is 0");
        if (i>j){
          validate(dist[i][j]==dist[j][i], "Matrix is not symmetric");
        }
      }
      rist[i][j]=dist[i][j];
    }
    assert(dist[i][i]==0);
  }

  for (int i=n; i--;)
    for (int j=n; j--;)
      for (int k=n; k--;)
        rist[j][k]=std::min(rist[j][k],rist[j][i]+rist[i][k]);

  for (int i=n; i--;)
    for (int j=n; j--;)
      validate(rist[i][j]==dist[i][j], "Matrix is not a transitive closure");

  return 42;
}
