#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct Shop{
  ll open,close,rate;
};

struct Edge{
  ll time,stime,a,b;
  bool operator<(Edge const &a)const{
    return time<a.time or time==a.time and stime<a.stime;
  }
};

int main(){
  ll data; cin>>data;

  int n; cin>>n;
  vector<Shop> coffee(n); for (auto &i: coffee) cin>>i.open>>i.close>>i.rate;

  vector<vector<ll>> dist(n,vector<ll>(n));
  vector<Edge> edges;
  for (int i=0; i<n; i++){
    for (int j=0; j<n; j++){
      cin>>dist[i][j];
      if (i==j){
        continue;
      }
      if (coffee[j].open-dist[i][j]>=coffee[i].open and coffee[j].open-dist[i][j]<=coffee[i].close){
        edges.push_back({coffee[j].open, coffee[j].open-dist[i][j], i, j});
      }
      if (coffee[i].close+dist[i][j]<=coffee[j].close){
        edges.push_back({max(coffee[i].close+dist[i][j], coffee[j].open), coffee[i].close, i, j});
      }
    }
  }

  vector<map<int,int>> best(n);
  for (int i=0; i<n; i++){
    best[i][coffee[i].open]=0-coffee[i].rate*coffee[i].open;
  }

  sort(edges.begin(),edges.end());
  for (auto e: edges){
    auto it=best[e.a].upper_bound(e.stime);
    if (it==best[e.a].begin()) continue; else --it;

    ll data_at=it->second+e.stime*coffee[e.a].rate;
    ll score=data_at-e.time*coffee[e.b].rate;
    if (score>best[e.b].rbegin()->second){
      best[e.b][e.time]=score;
    }
  }

  ll res=(1ll<<50ll);
  for (int i=0; i<n; i++){
    for (auto it: best[i]){
      if (it.second+coffee[i].rate*it.first<=data and
          it.second+coffee[i].rate*coffee[i].close>=data){
        res=min(res,(data-it.second+coffee[i].rate-1)/coffee[i].rate);
      }
    }
  }

  if (res==(1ll<<50ll)){
    cout<<"impossible"<<endl;
  }else{
    cout<<res<<endl;
  }
}
