#!/bin/bash

set -e
set -o pipefail

GEN='pypy ../generators/gen/random_generator.py'
SOLVER='../submissions/accepted/rgl-diff.py'

# First test case ID
TCID=50

testcase() {
  generator="$1"
  name="$2"
  ${generator} --name="${name}" "${@:3}" \
   > "$(printf 'secret/%03d-%s.in' "${TCID}" "${name}")" \
   &

  sleep 0
  ((TCID++))
  if { ( ((TCID%5 == 0)) ) } then wait; fi
}

echo "Creating secret data directory"
mkdir -p secret
find secret -mindepth 1 -not -name '*hand*' -delete

for i in {1..40} ; do
  testcase "${GEN}" uniform-$i
done

## Solve all the cases

echo "Compiling solution"
for test_in in secret/*.in
  do
    echo "Solving case ${test_in}"
    test_ans="$(dirname "${test_in}")"/"$(basename "${test_in}" ".in").ans"
    ${SOLVER} <"${test_in}" 1>"${test_ans}" # 2>/dev/null &
  done
