#!/usr/bin/env python
from math import sqrt

data = raw_input().split()
n = int(data[0])
cash = int(data[1])
factor = float(data[2])

def payout(d):
  return max(0, cash - pow(factor * d, 2))

def chance(d):
  if 0 <= d < n:
    return 1.0 / (n - d)
  else:
    return 0.0

def stationary_points():
  yield 0
  yield n-1
  discriminant = 4*pow(pow(factor,2)*n,2)-4*cash*pow(factor,2)
  if discriminant >= 0:
    d = int(n - sqrt(discriminant) / (2*pow(factor,2)))
    d= int(d)
    if 0 <= d < n: yield d
    if 0 <= d+1 < n: yield d+1

best = (-1, -1)
for d in stationary_points():
  best = max(best, (payout(d) * chance(d), d))

print '%0.20f' % (payout(d) * chance(d))
